package com.xymc.vexonlinetime.Event;

package .tmp;

import com.xymc.vexonlinetime.main.MainPlugin;
import com.xymc.vexonlinetime.model.MessageConfig;
import com.xymc.vexonlinetime.model.StateImgConfig;
import com.xymc.vexonlinetime.model.TimeConfig;
import com.xymc.vexonlinetime.model.TitleConfig;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import lk.vexview.api.VexViewAPI;
import lk.vexview.event.ButtonClickEvent;
import lk.vexview.event.gui.VexGuiCloseEvent;
import lk.vexview.gui.OpenedVexGui;
import lk.vexview.gui.components.DynamicComponent;
import lk.vexview.gui.components.VexComponents;
import lk.vexview.gui.components.VexText;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.plugin.Plugin;

public class VexEvent implements Listener {
  public static HashMap<String, Integer> playerPages = new HashMap<>();
  
  @EventHandler
  public void playerJoinEvent(PlayerJoinEvent event) {
    Player player = event.getPlayer();
    playerPages.put(player.getName(), Integer.valueOf(1));
  }
  
  @EventHandler
  public void closeEvent(VexGuiCloseEvent event) {
    Player player = event.getPlayer();
    playerPages.put(player.getName(), Integer.valueOf(1));
  }
  
  @EventHandler
  public void clickLeftRightEvent(ButtonClickEvent event) {
    Player player = event.getPlayer();
    if (event.getButtonID().equals(Integer.valueOf(10)) || event.getButtonID().equals(Integer.valueOf(11))) {
      OpenedVexGui openedVexGui = VexViewAPI.getPlayerCurrentGui(player);
      int page = ((Integer)playerPages.get(player.getName())).intValue();
      if (event.getButtonID().equals(Integer.valueOf(10)))
        if (((Integer)playerPages.get(player.getName())).intValue() > 1) {
          playerPages.put(player.getName(), Integer.valueOf(page - 1));
          deleteComponents(player);
          File playerDataFile = new File(new File(MainPlugin.plugin.getDataFolder(), "Data"), player.getName() + ".yml");
          YamlConfiguration playerYml = YamlConfiguration.loadConfiguration(playerDataFile);
          List<String> timeList = new ArrayList<>(playerYml.getStringList("list"));
          for (int i = 1; i <= 4; i++) {
            int key = (page - 2) * 4 + i;
            TimeConfig timeConfig;
            if ((timeConfig = (TimeConfig)TimeConfig.getTimeConfigMap().get(Integer.valueOf(key))) != null)
              addComponents(player, timeConfig, timeList, i); 
          } 
        } else {
          return;
        }  
      if (event.getButtonID().equals(Integer.valueOf(11)))
        if (TimeConfig.getTimeConfigMap().size() > page * 4) {
          playerPages.put(player.getName(), Integer.valueOf(page + 1));
          deleteComponents(player);
          File playerDataFile = new File(new File(MainPlugin.plugin.getDataFolder(), "Data"), player.getName() + ".yml");
          YamlConfiguration playerYml = YamlConfiguration.loadConfiguration(playerDataFile);
          List<String> timeList = new ArrayList<>(playerYml.getStringList("list"));
          for (int i = 1; i <= 4; ) {
            int key = page * 4 + i;
            TimeConfig timeConfig;
            if ((timeConfig = (TimeConfig)TimeConfig.getTimeConfigMap().get(Integer.valueOf(key))) != null) {
              addComponents(player, timeConfig, timeList, i);
              i++;
            } 
          } 
        } else {
          return;
        }  
    } 
  }
  
  @EventHandler
  public void clickTimeButtonEvent(ButtonClickEvent event) {
    Player player = event.getPlayer();
    if (event.getButtonID().equals(Integer.valueOf(1)) || event.getButtonID().equals(Integer.valueOf(2)) || event.getButtonID().equals(Integer.valueOf(3)) || event.getButtonID().equals(Integer.valueOf(4))) {
      int timeId = (((Integer)playerPages.get(player.getName())).intValue() - 1) * 4;
      timeId += ((Integer)event.getButtonID()).intValue();
      TimeConfig timeConfig;
      if ((timeConfig = (TimeConfig)TimeConfig.getTimeConfigMap().get(Integer.valueOf(timeId))) == null) {
        player.sendMessage("无礼包可领取");
        return;
      } 
      OpenedVexGui openedVexGui = VexViewAPI.getPlayerCurrentGui(player);
      File playerDataFile = new File(new File(MainPlugin.plugin.getDataFolder(), "Data"), player.getName() + ".yml");
      YamlConfiguration playerYml = YamlConfiguration.loadConfiguration(playerDataFile);
      List<String> timeList = new ArrayList<>(playerYml.getStringList("list"));
      if (!timeList.contains(timeConfig.getId())) {
        if (((Integer)MainPlugin.PLAYER_TIME_MAP.get(player.getName())).intValue() >= timeConfig.getTime()) {
          timeList.add(timeConfig.getId());
          playerYml.set("list", timeList);
          try {
            playerYml.save(playerDataFile);
          } catch (IOException e) {
            e.printStackTrace();
          } 
          openedVexGui.addDynamicComponent((DynamicComponent)StateImgConfig.getSuccessVexImage());
          openedVexGui.addDynamicComponent((DynamicComponent)((MessageConfig)MessageConfig.getVexTextMap().get("success")).getVexText());
          (new Object(this, openedVexGui, player, timeConfig))























            
            .runTaskLaterAsynchronously((Plugin)MainPlugin.plugin, 10L);
        } else {
          openedVexGui.addDynamicComponent((DynamicComponent)StateImgConfig.getFailVexImage());
          openedVexGui.addDynamicComponent((DynamicComponent)((MessageConfig)MessageConfig.getVexTextMap().get("fail")).getVexText());
          (new Object(this, openedVexGui))





            
            .runTaskLaterAsynchronously((Plugin)MainPlugin.plugin, 10L);
        } 
      } else {
        openedVexGui.addDynamicComponent((DynamicComponent)StateImgConfig.getFailVexImage());
        openedVexGui.addDynamicComponent((DynamicComponent)((MessageConfig)MessageConfig.getVexTextMap().get("repeat")).getVexText());
        (new Object(this, openedVexGui))





          
          .runTaskLaterAsynchronously((Plugin)MainPlugin.plugin, 10L);
      } 
    } 
  }
  
  private void deleteComponents(Player player) {
    OpenedVexGui openedVexGui = VexViewAPI.getPlayerCurrentGui(player);
    List<VexComponents> vexComponentsList = new ArrayList<>(openedVexGui.getVexGui().getComponents());
    for (VexComponents vexComponents : vexComponentsList) {
      if (vexComponents instanceof VexText) {
        VexText vexText = (VexText)vexComponents;
        if (!((String)vexText.getText().get(0)).equals(TitleConfig.getTitleConfig().getTitle()) && !((String)vexText.getText().get(0)).contains("§0§0§0§0")) {
          openedVexGui.getVexGui().getComponents().remove(vexText);
          openedVexGui.removeDynamicComponent((DynamicComponent)vexText);
        } 
      } 
    } 
  }
  
  private void addComponents(Player player, TimeConfig timeConfig, List<String> timeList, int i) {
    OpenedVexGui openedVexGui = VexViewAPI.getPlayerCurrentGui(player);
    openedVexGui.addDynamicComponent((DynamicComponent)new VexText(timeConfig.getTitleX(), timeConfig.getTitleY(), Arrays.asList(new String[] { timeConfig.getTitleText() })));
    openedVexGui.addDynamicComponent((DynamicComponent)new VexText(timeConfig.getDescX(), timeConfig.getDescY(), timeConfig.getDescTextList()));
    if (timeList.contains(timeConfig.getId())) {
      openedVexGui.setButtonClickable(Integer.valueOf(i), false);
    } else {
      openedVexGui.setButtonClickable(Integer.valueOf(i), true);
    } 
  }
}
